
import random
import pygame
from pygame import gfxdraw
from pygame import Surface
from pygame import Rect
import math

class Enemy:

    def __init__(self,window,sprites,rect,direction = 1,vel = 5) -> None:
        self.rect = Rect(rect)
        self.sprites = sprites
        self.window = window
        self.died = False
        self.is_exploding = False
        self.vel = vel
        self.direction = direction
        self.next_frame = 0
        self.currentFrame = 0
        
        

    def show(self):
        if not self.died:
            self.window.blit(self.sprites[self.currentFrame], (self.rect.x,self.rect.y))

    def update(self):
        w,h = self.window.get_width(),self.window.get_height()
        

        if self.rect.left <= 0:
            self.rect.left = 0

            if self.direction <= 180:
                self.direction = (180 - self.direction) + random.randint(-1,2)
            else: 
                self.direction = (180 - self.direction) + random.randint(-1,2)
                
        elif self.rect.right >= w: 
            self.rect.right = w
            if self.direction <= 180:
                self.direction = (180 - self.direction) + random.randint(-1,2)
            else: 
                self.direction = (540 - self.direction) + random.randint(-1,2)

        elif self.rect.top <= 0:
            self.rect.top = 0
            self.direction = (360 - self.direction) + random.randint(-1,2)

        elif self.rect.bottom >= h - 80:
            self.rect.bottom = h - 80
            self.direction = (360 - self.direction) + random.randint(-1,2)

        dirRad = math.radians(self.direction)

        self.rect.x += math.cos(dirRad) * self.vel
        self.rect.y += math.sin(dirRad) * self.vel

        if self.is_exploding:
            if self.next_frame <= 0:
                self.currentFrame += 1
                if self.currentFrame >= len(self.sprites):
                    self.died = True
                self.next_frame = 10
            else:
                self.next_frame -= 1
        

    def collide(self,rectObj):
            return True if self.rect.colliderect(rectObj) and not self.is_exploding else False
